using System;
using System.ComponentModel;

namespace Dapfor.Net.Grid.Benchmark
{
    /// <summary>
    /// Some test class that implements <see cref="INotifyPropertyChanged"/> interface
    /// </summary>
    internal sealed class EventPublisherDataObject : INotifyPropertyChanged
    {
        static readonly Random _random = new Random();

        private int _value0;
        private int _value1;
        private int _value2;
        private int _value3;
        private int _value4;
        private int _value5;
        private int _value6;
        private int _value7;
        private int _value8;
        private int _value9;

        public EventPublisherDataObject()
        {
            _value0 = _random.Next();
            _value1 = _random.Next();
            _value2 = _random.Next();
            _value3 = _random.Next();
            _value4 = _random.Next();
            _value5 = _random.Next();
            _value6 = _random.Next();
            _value7 = _random.Next();
            _value8 = _random.Next();
            _value9 = _random.Next();
        }

        public int Value0
        {
            get { return _value0; }
            set
            {
                if (_value0 != value)
                {
                    _value0 = value;
                    NotifyUpdate("Value0");
                }
            }
        }

        public int Value1
        {
            get { return _value1; }
            set
            {
                if (_value1 != value)
                {
                    _value1 = value;
                    NotifyUpdate("Value1");
                }
            }
        }

        public int Value2
        {
            get { return _value2; }
            set
            {
                if (_value2 != value)
                {
                    _value2 = value;
                    NotifyUpdate("Value2");
                }
            }
        }

        public int Value3
        {
            get { return _value3; }
            set
            {
                if (_value3 != value)
                {
                    _value3 = value;
                    NotifyUpdate("Value3");
                }
            }
        }

        public int Value4
        {
            get { return _value4; }
            set
            {
                if (_value4 != value)
                {
                    _value4 = value;
                    NotifyUpdate("Value4");
                }
            }
        }

        public int Value5
        {
            get { return _value5; }
            set
            {
                if (_value5 != value)
                {
                    _value5 = value;
                    NotifyUpdate("Value5");
                }
            }
        }

        public int Value6
        {
            get { return _value6; }
            set
            {
                if (_value6 != value)
                {
                    _value6 = value;
                    NotifyUpdate("Value6");
                }
            }
        }

        public int Value7
        {
            get { return _value7; }
            set
            {
                if (_value7 != value)
                {
                    _value7 = value;
                    NotifyUpdate("Value7");
                }
            }
        }

        public int Value8
        {
            get { return _value8; }
            set
            {
                if (_value8 != value)
                {
                    _value8 = value;
                    NotifyUpdate("Value8");
                }
            }
        }

        public int Value9
        {
            get { return _value9; }
            set
            {
                if (_value9 != value)
                {
                    _value9 = value;
                    NotifyUpdate("Value9");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyUpdate(string field)
        {
            if(PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(field));
            }
        }
    }
}